<template>
    <div class="edit-view">
        <el-form :model="formData" :rules="rules" ref="form" label-width="80px" label-position="right" size="small"
                 style="max-width: 500px;">
                <el-form-item prop="orderId" label="订单ID">
                            <el-input-number type="number" v-model="formData.orderId"></el-input-number>
                </el-form-item>
                <el-form-item prop="target" label="投诉目标">
                            <el-input v-model="formData.target"></el-input>
                </el-form-item>
                <el-form-item prop="type" label="投诉类型">
                            <el-input v-model="formData.type"></el-input>
                </el-form-item>
                <el-form-item prop="img" label="图片">
                            <el-input v-model="formData.img"></el-input>
                </el-form-item>
                <el-form-item prop="content" label="内容">
                            <el-input v-model="formData.content"></el-input>
                </el-form-item>
                <el-form-item prop="resolve" label="是否解决">
                            <el-switch v-model="formData.resolve"></el-switch>
                </el-form-item>
                <el-form-item prop="time" label="投诉时间">
                            <el-date-picker
                                    v-model="formData.time"
                                    type="datetime"
                                    value-format="yyyy-MM-dd HH:mm:ss"
                                    placeholder="选择日期时间">
                            </el-date-picker>
                </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving"
                           type="primary">保存</el-button>
                <el-button @click="onDelete" :loading="saving"
                           type="danger" v-if="formData.id">删除
                </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
    export default {
        name: 'ComplaintEdit',
        created() {
            if (this.$route.query.id) {
                this.$http
                    .get('complaint/get/'+this.$route.query.id)
                    .then(res => {
                        this.formData = res;
                    })
                    .catch(e => {
                        console.log(e);
                        this.$message.error(e.error);
                    });
            }
        },
        data() {
            return {
                saving: false,
                formData: {
                },
                rules: {
                },
            }
        },
        methods: {
            onSave() {
                this.$refs.form.validate((valid) => {
                    if (valid) {
                        this.submit();
                    } else {
                        return false;
                    }
                });
            },
            submit() {
                let data = {...this.formData};

                this.saving = true;
                this.$http
                    .post('/complaint/save', data, {body: 'json'})
                    .then(res => {
                        this.saving = false;
                        this.$message.success('成功');
                        this.$router.go(-1);
                    })
                    .catch(e => {
                        console.log(e);
                        this.saving = false;
                        this.$message.error(e.error);
                    });
            },
            onDelete() {
                this.$alert('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/complaint/del/${this.formData.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                }).catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                })
            },
        }
    }
</script>
<style lang="less" scoped>
</style>
